unit Visuel_Commande;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, WSocket;

type
  TForm1 = class(TForm)
    // GUI Composants
    box_connection: TGroupBox;
    edit_ip: TEdit;
    lbl_ip: TLabel;
    lbl_port: TLabel;
    edit_port: TEdit;
    box_movement: TGroupBox;
    btn_close: TButton;
    pnl_socle: TPanel;
    pnl_epaule: TPanel;
    pnl_coude: TPanel;
    pnl_poignet: TPanel;
    pnl_pince: TPanel;
    lbl_socle: TLabel;
    lbl_epaule: TLabel;
    lbl_coude: TLabel;
    lbl_poignet: TLabel;
    lbl_pince: TLabel;
    btn_socle_gauche: TButton;
    btn_socle_stop: TButton;
    btn_socle_droite: TButton;
    btn_epaule_gauche: TButton;
    btn_epaule_stop: TButton;
    btn_epaule_droite: TButton;
    btn_coude_gauche: TButton;
    btn_coude_stop: TButton;
    btn_coude_droite: TButton;
    btn_poignet_gauche: TButton;
    btn_poignet_stop: TButton;
    btn_poignet_droite: TButton;
    btn_pince_gauche: TButton;
    btn_pince_stop: TButton;
    btn_pince_droite: TButton;
    btn_connect: TButton;
    btn_deconnect: TButton;
    edit_prog: TEdit;
    // TWSocket pour tre capable de connecter sur le serveur
    WSocket: TWSocket;
    // Functions pour les boutons
    procedure btn_connectClick(Sender: TObject);
    procedure btn_deconnectClick(Sender: TObject);
    procedure btn_socle_gaucheClick(Sender: TObject);
    procedure btn_socle_stopClick(Sender: TObject);
    procedure btn_socle_droiteClick(Sender: TObject);
    procedure btn_epaule_gaucheClick(Sender: TObject);
    procedure btn_epaule_stopClick(Sender: TObject);
    procedure btn_epaule_droiteClick(Sender: TObject);
    procedure btn_coude_gaucheClick(Sender: TObject);
    procedure btn_coude_stopClick(Sender: TObject);
    procedure btn_coude_droiteClick(Sender: TObject);
    procedure btn_poignet_gaucheClick(Sender: TObject);
    procedure btn_poignet_stopClick(Sender: TObject);
    procedure btn_poignet_droiteClick(Sender: TObject);
    procedure btn_pince_gaucheClick(Sender: TObject);
    procedure btn_pince_stopClick(Sender: TObject);
    procedure btn_pince_droiteClick(Sender: TObject);
    procedure btn_closeClick(Sender: TObject);
    // Mthodes du Socket 
    procedure onErr(Sender: TObject);
    procedure onSAvailable(Sender: TObject; Error: Word);
    procedure onSClosed(Sender: TObject; Error: Word);
    procedure onSConnected(Sender: TObject; Error: Word);
    procedure onSError(Sender: TObject; Error: Integer; Msg: String);
    procedure WSocketBgException(Sender: TObject; E: Exception;
      var CanClose: Boolean);

  private
    ConnectError:Word;
    procedure send_fw(FW : byte);
  public

  end;

var
  Form1: TForm1;

//------------------------------------------------------------------------------
// Implmentation des procdures
//------------------------------------------------------------------------------

implementation

{$R *.dfm}

// quand vous pousez le bouton 'connect'
procedure TForm1.btn_connectClick(Sender: TObject);
begin
  with WSocket do
    begin
        if State <> wsConnected then
        begin
          Addr := edit_ip.Text;
          Port := edit_port.Text;
          Proto := 'tcp';
          Connect;
          while State in [WsConnecting] do
          begin
            Application.ProcessMessages;
            if Application.Terminated then
              Exit;
          end;
        if State = WsConnected then
        begin
          box_movement.Enabled := True;
        end;
        end;
    end;
end;

// quand vous pousez le bouton 'deconnect'
procedure TForm1.btn_deconnectClick(Sender: TObject);
begin
  Wsocket.Close;
end;

// procedure pour envoyer les flagwords
procedure TForm1.send_fw(FW:byte);
begin
  if WSocket.State = WsConnected then
  begin
    WSocket.SendStr(chr(FW));
  end;
end;

// procedure pour les errors
procedure TForm1.WSocketBgException(Sender: TObject; E: Exception;
  var CanClose: Boolean);
begin
  edit_prog.Text := 'Impossible de connecter avec le Robot';
end;

//------------------------------------------------------------------------------
// Tous les boutons
//------------------------------------------------------------------------------
procedure TForm1.btn_socle_gaucheClick(Sender: TObject);
begin
  send_fw($D5);
end;

procedure TForm1.btn_socle_stopClick(Sender: TObject);
begin
  send_fw($C5);
end;

procedure TForm1.btn_socle_droiteClick(Sender: TObject);
begin
  send_fw($E5);
end;

procedure TForm1.btn_epaule_gaucheClick(Sender: TObject);
begin
  send_fw($D4);
end;

procedure TForm1.btn_epaule_stopClick(Sender: TObject);
begin
  send_fw($C4);
end;

procedure TForm1.btn_epaule_droiteClick(Sender: TObject);
begin
  send_fw($E4);
end;

procedure TForm1.btn_coude_gaucheClick(Sender: TObject);
begin
  send_fw($E3);
end;

procedure TForm1.btn_coude_stopClick(Sender: TObject);
begin
  send_fw($C3);
end;

procedure TForm1.btn_coude_droiteClick(Sender: TObject);
begin
  send_fw($D3);
end;

procedure TForm1.btn_poignet_gaucheClick(Sender: TObject);
begin
  send_fw($D2);
end;

procedure TForm1.btn_poignet_stopClick(Sender: TObject);
begin
  send_fw($C2);
end;

procedure TForm1.btn_poignet_droiteClick(Sender: TObject);
begin
  send_fw($E2);
end;

procedure TForm1.btn_pince_gaucheClick(Sender: TObject);
begin
  send_fw($D1);
end;

procedure TForm1.btn_pince_stopClick(Sender: TObject);
begin
  send_fw($C1);
end;

procedure TForm1.btn_pince_droiteClick(Sender: TObject);
begin
  send_fw($E1);
end;

// fermer le form
procedure TForm1.btn_closeClick(Sender: TObject);
begin
  Form1.Close;
end;

// Capter des erreurs
procedure TForm1.onErr(Sender: TObject);
begin
  edit_prog.Text := 'ERROR';
end;

// On Session Available
procedure TForm1.onSAvailable(Sender: TObject; Error: Word);
begin
  edit_prog.Text := 'Session Available';
end;

// On Session Closed
procedure TForm1.onSClosed(Sender: TObject; Error: Word);
begin
  edit_prog.Text := 'Fin Connexion';
  btn_connect.Enabled := True;
  btn_deconnect.Enabled := False;
  box_movement.Enabled := False;
end;

// On Session Connected
procedure TForm1.onSConnected(Sender: TObject; Error: Word);
begin
  ConnectError := Error;
  if ConnectError <> 0 then
    edit_prog.Text := 'Connexion Impossible, ERREUR!'
  else
  begin
    edit_prog.Text := 'Connexion ralise';
    btn_connect.Enabled := False;
    btn_deconnect.Enabled := True;
  end;
end;

// On Session Error
procedure TForm1.onSError(Sender: TObject; Error: Integer; Msg: String);
begin
  edit_prog.Text := 'Socks Error';
end;



end.

