unit RobotClass;

interface

uses Windows, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls,
ExtCtrls, Messages, EtatClass, RobotViewerClass;

type

TRobot = class;
// ------------ Mise en forme de la classe TMoteur -----------------------------
TMoteur = class(TComponent)

  constructor Create(AOwner:Tcomponent;v:integer;n:String;ax:integer;ix:integer;p:integer;r:TRobot);//override;
  Destructor Destroy;

private
  // -- Les Variables --
  Timer:TTimer;
  Interval:Cardinal;

  OnOff:boolean; {S'il est en marche ou pas}
  DroiteGauche:boolean; // 1 --> droite, 0 --> gauche {La direction qu'il prend}

  Nom:string;
  AngleMin:integer;
  AngleMax:integer;
  Position:integer;
  Vitesse:integer;

  Robot:TRobot;

public
  // -- Les Mthodes --
  procedure TourneDroite();
  procedure TourneGauche();
  procedure Bouger(Sender:TObject);
  procedure StopBouger();
  function GetPosition():integer;
  procedure SetPosition(val:integer);
  procedure SetPositionButee(val:integer);
end;
// ------------ Fin de la mise en forme ----------------------------------------


// ------------ Mise en forme de la classe -------------------------------------
TRobot = class

  Constructor Create;
  Destructor Destroy;

private
  // -- Les Variables --
  {Ces cinq moteurs}
  SocleMoteur : TMoteur;
  EpauleMoteur : TMoteur;
  CoudeMoteur : TMoteur;
  PinceMoteur : TMoteur;
  PoignetMoteur : TMoteur;
  {Son tat}
  EtatRobot : TEtat;

  RobotViewer : TRobotViewer;
  {Les butes de ces cinq moteurs}
  ButeesMoteurs : array [0..5] of integer; //1 bute gauche, 2 pas bute
                                                // 3 bute droite
public
  // -- Les Mthodes --
  procedure setRobotViewer(RV:TRobotViewer);
  function Bouche(FW:byte):String;
  procedure metMaValeur(MType:String; Valeur:Integer);
  procedure metMaButee(MType:String;BGoD:Integer);

  procedure SetButees(SV:integer;EV:integer;CV:integer;PV:integer;PIV:integer);
  procedure SetPositionCoude(val:integer);
  procedure SetPositionPoignet(val:integer);

  procedure ArreteTout();
end;
// ------------ Fin de la mise en forme ----------------------------------------


implementation

//------------------------------------------------------------------------------
// Des TROBOT
//------------------------------------------------------------------------------

  {Creation des 5 moteur du robot avec leurs valuers des vitesse, nom, etc, qui
   se trouvent dans un fichier "PropRobot.ini".}
  Constructor TRobot.Create();
  var
    t1,butee : integer;
    vitesse, anglemax, anglemin, position : integer;
    nom : string;

    iFileHandle, iFileLength, iBytesRead:Integer;
    Buffer:PChar;
    i,place:Integer;
    KindValue,Value:String;
  begin
    try

      place := 1; KindValue := ''; Value := '';

      {Ouvrir d'un fichier et lire les donnes dans un buffer}
      iFileHandle :=FileOpen('PropRobot.ini',fmOpenRead);
      iFileLength :=FileSeek(iFileHandle,0,2);
      FileSeek(iFileHandle,0,0);
      Buffer :=PChar(AllocMem(iFileLength +1));
      iBytesRead :=FileRead(iFileHandle,Buffer^,iFileLength);
      FileClose(iFileHandle);

      {L'analyse de cette buffer, trouver la partie devant '=' et devant ';'}
      for i := 0 to iBytesRead-1 do
      begin
        if ((Buffer[i] <> '=') And (Buffer[i] <> ';') And (place = 1)) then
        begin
          KindValue := KindValue + Buffer[i];
        end;
        if (Buffer[i] = '=') then
        begin
          place := 2;
        end;
        if ((Buffer[i] <> '=') And (Buffer[i] <> ';') And (place = 2)) then
        begin
          Value := Value + Buffer[i];
        end;
        if (Buffer[i] = ';') then
        begin
          place := 3;
          {De quelle proprit il s'agit et mettre dans la propre variable}
          if (KindValue = 'nom') then
            nom := Value;
          if (KindValue = 'vitesse') then
            vitesse := StrToInt(Value);
          if (KindValue = 'angleMax') then
            anglemax := StrToInt(Value);
          if (KindValue = 'angleMin') then
            anglemin := StrToInt(Value);
          if (KindValue = 'position') then
          begin
            if (position <= angleMin) then   {La possibil qu'un robot commence}
              butee := 3;                    {a une position deja bute}
            if (position >= angleMax) then
              butee := 1;
            if ((position > angleMin) And (position < angleMax))then
              butee := 2;
            position := StrToInt(Value);
            case nom[1] of                   {La cration des cinq moteurs}
              'S'{ocle'} : SocleMoteur := TMoteur.Create(TComponent(Self),vitesse,nom,anglemax,anglemin,position,self);
              'E'{paule'} : EpauleMoteur := TMoteur.Create(TComponent(Self),vitesse,nom,anglemin,-anglemax,-position,self);
              'C'{oude'} : CoudeMoteur := TMoteur.Create(TComponent(Self),vitesse,nom,anglemin,-anglemax,-position,self);
              'P'{oignet'} : PoignetMoteur := TMoteur.Create(TComponent(Self),vitesse,nom,anglemax,anglemin,position,self);
              'N'{pince'} : PinceMoteur := TMoteur.Create(TComponent(Self),vitesse,nom,anglemax,anglemin,position,self);
            end;
            case nom[1] of                   {Les valeurs des butes}
              'S'{ocle'} : ButeesMoteurs[1] := butee;
              'E'{paule'} : ButeesMoteurs[2] := butee;
              'C'{oude'} : ButeesMoteurs[3] := butee;
              'P'{oignet'} : ButeesMoteurs[4] := butee;
              'N'{pince'} : ButeesMoteurs[5] := butee;
            end;
          end;

          KindValue := '';
          Value := '';
        end;
        if (Buffer[i] = #$A) then            {Parce que aprs un ; il vient}
          place := 1;                        {encore un caractre nouveau ligne}

      end;
    finally
      FreeMem(Buffer);
    end;
                                    {L'tat: les positions des tous les moteurs}
    EtatRobot := TEtat.CreateAV(SocleMoteur.Position,EpauleMoteur.Position,CoudeMoteur.Position,PoignetMoteur.Position,PinceMoteur.Position);

  end;

  {Le dstructeur de la clase TRobot}
  Destructor TRobot.Destroy();
  begin
    SocleMoteur.Destroy;
    EpauleMoteur.Destroy;
    CoudeMoteur.Destroy;
    PinceMoteur.Destroy;
    PoignetMoteur.Destroy;
    RobotViewer := nil;

    EtatRobot.Free;

    SocleMoteur.Free;
    EpauleMoteur.Free;
    CoudeMoteur.Free;
    PinceMoteur.Free;
    PoignetMoteur.Free;
    RobotViewer.Free;
  end;

  procedure TRobot.setRobotViewer(RV:TRobotViewer);
  begin
    RobotViewer := RV;
    RobotViewer.setEtat(EtatRobot);
  end;

  {Dire au robot, bouge un de tes moteurs  une direction dtermin. Il te
   renvoie un string avec dedans la valeur qui indique un bute d'un moteur}
  function TRobot.Bouche(FW:byte):string;
  begin

    if FW = $E1 then
      begin
        PinceMoteur.TourneGauche;
        Bouche := '5' + IntToStr(ButeesMoteurs[5]);
      end;
    if FW = $D2 then
      begin
        PoignetMoteur.TourneGauche;
        Bouche := '4' + IntToStr(ButeesMoteurs[4]);
      end;
    if FW = $E3 then
      begin
        CoudeMoteur.TourneGauche;
        Bouche := '3' + IntToStr(ButeesMoteurs[3]);
      end;
    if FW = $D4 then
      begin
        EpauleMoteur.TourneGauche;
        Bouche := '2' + IntToStr(ButeesMoteurs[2]);
      end;
    if FW = $D5 then
      begin
        SocleMoteur.TourneGauche;
        Bouche := '1' + IntToStr(ButeesMoteurs[1]);
      end;
    if FW = $D1 then
      begin
        PinceMoteur.TourneDroite;
        Bouche := '5' + IntToStr(ButeesMoteurs[5]);
      end;
    if FW = $E2 then
      begin
        PoignetMoteur.TourneDroite;
        Bouche := '4' + IntToStr(ButeesMoteurs[4]);
      end;
    if FW = $D3 then
      begin
        CoudeMoteur.TourneDroite;
        Bouche := '3' + IntToStr(ButeesMoteurs[3]);
      end;
    if FW = $E4 then
      begin
        EpauleMoteur.TourneDroite;
        Bouche := '2' + IntToStr(ButeesMoteurs[2]);
      end;
    if FW = $E5 then
      begin
        SocleMoteur.TourneDroite;
        Bouche := '1' + IntToStr(ButeesMoteurs[1]);
      end;
    if FW = $C1 then
      begin
        PinceMoteur.StopBouger;
        Bouche := '5' + IntToStr(ButeesMoteurs[5]);
      end;
    if FW = $C2 then
      begin
        PoignetMoteur.StopBouger;
        Bouche := '4' + IntToStr(ButeesMoteurs[4]);
      end;
    if FW = $C3 then
      begin
        CoudeMoteur.StopBouger;
        Bouche := '3' + IntToStr(ButeesMoteurs[3]);
      end;
    if FW = $C4 then
      begin
        EpauleMoteur.StopBouger;
        Bouche := '2' + IntToStr(ButeesMoteurs[2]);
      end;
    if FW = $C5 then
      begin
        SocleMoteur.StopBouger;
        Bouche := '1' + IntToStr(ButeesMoteurs[1]);
      end;
  end;

  {Un Moteur peut mettre sa valeur de son position actuel}
  procedure TRobot.metMaValeur(MType:String; Valeur:Integer);
  begin
    case MType[1] of
      'S'{ocle'} : EtatRobot.SetSocleValeur(Valeur); // 1 --> Socle
      'E'{paule'} : EtatRobot.SetEpauleValeur(Valeur); // 2 --> Epaule
      'C'{oude'} : EtatRobot.SetCoudeValeur(Valeur); // 3 --> Coude
      'P'{oignet'} : EtatRobot.SetPoignetValeur(Valeur); // 4 --> Poignet
      'N'{pince'} : EtatRobot.SetPinceValeur(Valeur); // 5 --> Pince
    end;

    RobotViewer.setEtat(EtatRobot)

  end;

  {Un Moteur peut mettre sa valeur s'il est bute ou pas}
  procedure TRobot.metMaButee(MType:String;BGoD:Integer);
  begin
    case MType[1] of
      'S'{ocle'} : ButeesMoteurs[1] := BGoD; // 1 --> Socle
      'E'{paule'} : ButeesMoteurs[2] := BGoD; // 2 --> Epaule
      'C'{oude'} : ButeesMoteurs[3] := BGoD; // 3 --> Coude
      'P'{oignet'} : ButeesMoteurs[4] := BGoD; // 4 --> Poignet
      'N'{pince'} : ButeesMoteurs[5] := BGoD; // 5 --> Pince
    end;
  end;

  {Faire suivre les valeurs des butes au moteurs}
  procedure TRobot.SetButees(SV:integer;EV:integer;CV:integer;PV:integer;PIV:integer);
  begin
    SocleMoteur.SetPosition(SV);
    EpauleMoteur.SetPosition(EV);
    CoudeMoteur.SetPosition(CV);
    PoignetMoteur.SetPosition(PV);
    PinceMoteur.SetPosition(PIV);
  end;

  {Mettre la position de la coude}
  procedure TRobot.SetPositionCoude(val:integer);
  begin
    CoudeMoteur.SetPosition(360-val);
  end;

  {Mettre la position de le poignet}
  procedure TRobot.SetPositionPoignet(val:integer);
  begin
    PoignetMoteur.SetPosition(360-val);
  end;

  {Arrter tous les moteurs du robot}
  procedure TRobot.ArreteTout;
  begin
    PoignetMoteur.StopBouger;
    CoudeMoteur.StopBouger;
    EpauleMoteur.StopBouger;
    SocleMoteur.StopBouger;
  end;
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
// Des TMOTEUR
//------------------------------------------------------------------------------

  constructor TMoteur.Create(AOwner:Tcomponent;v:integer;n:String;ax:integer;ix:integer;p:integer;r:TRobot);
  begin
    Timer := TTimer.Create(Self);
    vitesse := v;
    Interval := vitesse;
    Timer.Interval := Interval;
    Timer.Enabled := False;
    Timer.OnTimer := Bouger;

    Robot := r;
    Nom := n;
    AngleMin := ix;
    AngleMax := ax;
    Position := p;
    DroiteGauche := True; // true = droite, false = gauche
  end;

  Destructor  TMoteur.Destroy;
  begin
    Timer.Free;
  end;

  {Dire au robot qu'il doit tourner  droite}
  procedure TMoteur.TourneDroite;
  begin
    OnOff := True;
    DroiteGauche := False;
    Timer.Enabled := True;
  end;

  {Dire au robot qu'il doit tourner  gauche}
  procedure TMoteur.TourneGauche;
  begin
    OnOff := True;
    DroiteGauche := True;
    Timer.Enabled := True;
  end;

  {chaque fois si le moteur est en marche, il voit sa direction et s'il n'est
  pas  la fin de son angle.}
  procedure TMoteur.Bouger;
  begin
    if OnOff = True then               {S'il est en marche}
    begin
      if DroiteGauche = true then      {Si la direction est Gauche}
        begin
          if Position < AngleMax then  {S'il n'arrive pas en bute}
          begin
            Position := Position + 1;
            robot.metMaValeur(nom,Position);
            robot.metMaButee(nom,2);
          end
          else
          begin                        {S'il arrive en bute}
            Timer.Enabled := False;
            robot.metMaButee(nom,1);
          end
        end
     else
        begin
          if Position > AngleMin then  {s'il n'arrive pas en bute}
          begin
            Position := Position - 1;
            robot.metMaValeur(nom,Position);
            robot.metMaButee(nom,2);
          end
          else
          begin                        {s'il arrive en bute}
            Timer.Enabled := False;
            robot.metMaButee(nom,3);
          end
        end
     end
  end;

  {Arrter le moteur}
  procedure TMoteur.StopBouger;
  begin
    OnOff := False;
    Timer.Enabled := False;
  end;

  {retourne sa position}
  function TMoteur.GetPosition():integer;
  begin
    GetPosition := integer(position);
  end;

  {mettre un nouveau position}
  procedure TMoteur.SetPosition(val:integer);
  begin
      position := val;
      robot.metMaValeur(nom,Position);
  end;

  {mettre en bute indiqu}
  procedure TMoteur.SetPositionButee(val:integer);
  begin
    if val = 1 then
      position := AngleMin;
    if val = 3 then
      position := AngleMax;

    robot.metMaValeur(nom,Position);
    robot.metMaButee(nom,val);
  end;
//------------------------------------------------------------------------------

end.

