unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, GLWin32Viewer, GLScene, GLObjects, GLMisc, GLTexture, GLFireFX,
  ExtCtrls, RobotClass, EtatClass, RobotViewerClass, WSocket,
  StdCtrls, WSocketS, TcpClass, GLGeomObjects, POSITIONS, UdpClass, Menus,
  frmOptionIpc, frmOptionServeur, frmOptionRobot, sauveVRML,jpeg;

type
// ------------ Mise en forme de la classe -------------------------------------
  TFrmSimulRobot = class(TForm)

    // -- Les choses pour le GLScene --
    MatLib: TGLMaterialLibrary;
    GLScene1: TGLScene;
    Lum1: TGLLightSource;
    Lum2: TGLLightSource;
    Lum3: TGLLightSource;
    Lum4: TGLLightSource;
    Ecorce: TGLSphere;
    Sol: TGLDisk;
    DC1: TGLDummyCube;
    Pied: TGLDummyCube;
    Bloc01: TGLCube;
    Bloc02: TGLCube;
    Socle: TGLCylinder;
    Bloc11: TGLCube;
    Articul1: TGLCylinder;
    Bras1: TGLCylinder;
    Articul2: TGLCylinder;
    Bras2: TGLCylinder;
    Poignet: TGLCylinder;
    Metacarpe: TGLFrustrum;
    Doigt1: TGLDummyCube;
    Pha11: TGLCube;
    ArtiD1: TGLDummyCube;
    Rot1: TGLCylinder;
    Pha12: TGLCube;
    Doigt2: TGLDummyCube;
    Pha21: TGLCube;
    ArtiD2: TGLDummyCube;
    Rot2: TGLCylinder;
    Pha22: TGLCube;
    CentreParts: TGLDummyCube;
    Cam1: TGLCamera;
    Viewer: TGLSceneViewer;
    SupportViewer: TPanel;
    GLSceneViewer1: TGLSceneViewer;
    EffetFeu: TGLFireFXManager;
    Particules: TGLFireFXManager;

    // -- Les Choses Visuel --
    WSocketServer1: TWSocketServer;
    btnValeurs: TButton;
    btnSimuleIpc: TButton;
    TmrGetValeurs: TTimer;
    MainMenu1: TMainMenu;
    Fichier1: TMenuItem;
    Proprits1: TMenuItem;
    IPC1: TMenuItem;
    Serveur1: TMenuItem;
    btnChargeValeurs: TButton;
    mmoServerMessages: TMemo;
    btnTcpServeur: TButton;
    lblTcpServeurOnOff: TLabel;
    Robot1: TMenuItem;
    lblMontreValeursOnOff: TLabel;
    lblSimuleIpcOnOff: TLabel;
    Fermer1: TMenuItem;

    // -- Form methodes --
    procedure OnCreate(Sender: TObject);
    procedure OnClose(Sender: TObject; var Action: TCloseAction);
    procedure WSocketServer1ClientConnect(Sender: TObject;
      Client: TWSocketClient; Error: Word);
    procedure WSocketServer1ClientDisconnect(Sender: TObject;
      Client: TWSocketClient; Error: Word);
    procedure WSocketServer1SessionClosed(Sender: TObject; Error: Word);

    procedure btnValeursClick(Sender: TObject);
    procedure btnSimuleIpcClick(Sender: TObject);
    procedure btnChargeValeursClick(Sender: TObject);
    procedure btnTcpServeurClick(Sender: TObject);

    procedure TmrGetValeursTimer(Sender: TObject);
    procedure TmrGetValeursButeeTimer(Sender: TObject);

    procedure IPC1Click(Sender: TObject);
    procedure Serveur1Click(Sender: TObject);
    procedure OnExit(Sender: TObject);
    procedure Robot1Click(Sender: TObject);
    procedure Fermer1Click(Sender: TObject);

  private

    // -- Les Objects --
    RobotViewer : TRobotViewer;
    Robot : TRobot;
    UdpClient : TUdpClient;
    SauveVRML : TSauveVRML;

    // -- Les Ecrans --
    FrmPosEcran : TFrmPosEcran;
    FrmOptionIPC : TFrmOptionIpc;
    FrmOptionServeur : TFrmOptionServeur;
    FrmOptionRobot : TFrmOptionRobot;

    // -- Les Variables --
    IpcPort : String;
    IpcAdresse : String;
    IpcVitesse : String;

    ServeurPort : String;
    ServeurAdresse : String;

    // -- Les Mthodes --
    procedure LireProprieteServeur();
    procedure LireProprieteIpc();

  public
    // -- Les Mthodes --
    procedure ReceiveAction(Sender: TObject; Action: byte);
    procedure MiseOptionIPC(P:string;A:string;V:String);

  end;
// ------------ Fin de la mise en forme ----------------------------------------


var
  FrmSimulRobot: TFrmSimulRobot;
  chemin:string;

  bmp:TBitmap;
    jpg:TJpegImage;
implementation

{$R *.dfm}

// ------------ Form Methodes --------------------------------------------------
procedure TFrmSimulRobot.OnCreate(Sender: TObject);
begin

  {Lire les fichier .ini}
  LireProprieteServeur;
  LireProprieteIpc;
  chemin:='c:\';

  {Les autres ecrans}
  FrmPosEcran := TFrmPosEcran.Create(Self);
  FrmOptionIPC := TfrmOptionIpc.Create(Self);
  FrmOptionServeur := TFrmOptionServeur.Create(Self);
  FrmOptionRobot := TFrmOptionRobot.Create(Self);

  {Les Object des Classes}
  RobotViewer := TRobotViewer.Create(Socle,Articul1,Articul2,Poignet,Doigt1,Doigt2,GLSceneViewer1);
  Robot := TRobot.Create;
  Robot.setRobotViewer(RobotViewer);
  SauveVRML := TSauveVRML.Create;  
  UdpClient := TUdpClient.Create(Self,IpcPort,IpcAdresse,StrToInt(IpcVitesse),FrmPosEcran);

  {SocketServeur}
  WSocketServer1.Port := ServeurPort;
  WSocketServer1.Addr := '0.0.0.0';
  WSocketServer1.ClientClass := TcpClient;
  WSocketServer1.Listen;

  //Instanciation du bmp de sauvegarde
 

end;

procedure TFrmSimulRobot.OnClose(Sender: TObject; var Action: TCloseAction);
begin
  RobotViewer.Free;
  Robot.Free;
  UDPClient.Free;
end;

procedure TFrmSimulRobot.OnExit(Sender: TObject);
begin
  RobotViewer.Free;
  Robot.Free;
  UDPClient.Free;
end;

// ------------ WSocketServer1 Methodes ----------------------------------------
{Cette mthode est provoqu quand un client se connecte sur TCP}
procedure TFrmSimulRobot.WSocketServer1ClientConnect(Sender: TObject;
  Client: TWSocketClient; Error: Word);
var
  Iclient: TcpClient;
begin
  Iclient := TcpClient(Client);
  Iclient.OnReceive := ReceiveAction; {S'il y arrive quelque chose}
  Iclient.Initialize;
  mmoServerMessages.Lines.Add('MS:Client en ligne.');
end;

{Cette mthode est provoqu quand un client se dconnecte du serveur}
procedure TFrmSimulRobot.WSocketServer1ClientDisconnect(Sender: TObject;
  Client: TWSocketClient; Error: Word);
var
  Iclient: TcpClient;
begin
  Iclient := TcpClient(Client);
  Iclient.Finalize;
  mmoServerMessages.Lines.Add('MS:Client hors ligne.');
  //Robot.ArreteTout;
end;

procedure TFrmSimulRobot.WSocketServer1SessionClosed(Sender: TObject; Error: Word);
begin
  Robot.ArreteTout;
end;

// ------------ Timer Methodes ------------------------------------------------
procedure TFrmSimulRobot.TmrGetValeursTimer(Sender: TObject);
var
  RV : String;
begin
  UdpClient.SetButee(Robot.Bouche(StrToInt(UdpClient.PFW1)));
  UdpClient.SetButee(Robot.Bouche(StrToInt(UdpClient.PFW2)));
  UdpClient.SetButee(Robot.Bouche(StrToInt(UdpClient.PFW3)));
  UdpClient.SetButee(Robot.Bouche(StrToInt(UdpClient.PFW4)));
  UdpClient.SetButee(Robot.Bouche(StrToInt(UdpClient.PFW5)));
end;

procedure TFrmSimulRobot.TmrGetValeursButeeTimer(Sender: TObject);
begin
  Robot.SetButees(UdpClient.PSV,UdpClient.PEV,UdpClient.PCV,UdpClient.PPV,UdpClient.PPIV);
  Robot.SetPositionCoude(UdpClient.PCoudePosition);
  Robot.SetPositionPoignet(UdpClient.PPoignetPosition);
end;

// ------------ Button Methodes ------------------------------------------------
{Commencer la simulation avec l'IPC. Pour retrouver les valeurs des butes
 et Angles. Ces valeurs sont prsent dans l'cran FrmPosEcran.}
procedure TFrmSimulRobot.btnValeursClick(Sender: TObject);
begin

  if (TmrGetValeurs.Enabled = False) then
  begin
    FrmPosEcran.Visible := true;                      {L'autre cran}
    UdpClient.CommenceComIPCAR;                       {Dire au UdpClient de}
    TmrGetValeurs.OnTimer := TmrGetValeursButeeTimer; {commencer sa communication}
    TmrGetValeurs.Enabled := true;
    btnTcpServeur.Enabled := False;
    btnSimuleIpc.Enabled := False;
    lblMontreValeursOnOff.Color := clgreen;
  end
  else
  begin
    FrmPosEcran.Visible := False;
    UdpClient.ArreteComIPC;
    TmrGetValeurs.Enabled := False;
    btnTcpServeur.Enabled := True;
    btnSimuleIpc.Enabled := True;
    lblMontreValeursOnOff.Color := clred;
  end;

end;

{Commencer la simulation avec l'IPC. Pour retrouver les valeurs des Flag Words
 et avec eux on simula le mouvement du robot}
procedure TFrmSimulRobot.btnSimuleIpcClick(Sender: TObject);
begin
  if (TmrGetValeurs.Enabled = False) then
  begin
    UdpClient.CommenceComIPCSR;
    TmrGetValeurs.OnTimer := TmrGetValeursTimer;
    TmrGetValeurs.Enabled := true;
    btnTcpServeur.Enabled := False;
    btnValeurs.Enabled := False;
    lblSimuleIpcOnOff.Color := clgreen;
  end
  else
  begin
    UdpClient.ArreteComIPC;
    TmrGetValeurs.Enabled := False;
    btnTcpServeur.Enabled := True;
    btnValeurs.Enabled := True;
    lblSimuleIpcOnOff.Color := clred;
  end;
end;

{Commencer le serveur, ou arrter le serveur}
procedure TFrmSimulRobot.btnTcpServeurClick(Sender: TObject);
begin
  if (WSocketServer1.State = WSListening) Or (WSocketServer1.State = WSConnected) then
  begin
    if (WSocketServer1.ClientCount > 0) then
    begin
      if (WSocketServer1.Client[0].State = WSConnected) then
      begin
        WSocketServer1.Client[0].Close;     {S'il y a des Clients connecter}
      end;                                  {Les dconnectent avant d'arrter}
    end;                                    {le serveur}
    WSocketServer1.Close;
    lblTcpServeurOnOff.Color := clred;
    btnValeurs.Enabled := true;
    btnSimuleIpc.Enabled := true;
  end
  else if WSocketServer1.State = WSClosed then
  begin
    btnValeurs.Enabled := false;
    btnSimuleIpc.Enabled := false;
    WSocketServer1.Port := ServeurPort;
    WSocketServer1.Addr := '0.0.0.0';
    WSocketServer1.ClientClass := TcpClient;
    WSocketServer1.Listen;
    lblTcpServeurOnOff.Color := clgreen;
  end;

end;

{Si un des fichier avec les propits du serveur, de l'IPC ou du robot, est
 modifier. On peut avec ce bouton-ci charger ces valeurs.}
procedure TFrmSimulRobot.btnChargeValeursClick(Sender: TObject);
begin
  //Lire les fichier .ini
  LireProprieteServeur;
  LireProprieteIpc;

  UDPClient.Free;

  //Instanciations des Objects des Classes
  RobotViewer := TRobotViewer.Create(Socle,Articul1,Articul2,Poignet,Doigt1,Doigt2,GLSceneViewer1);
  Robot := TRobot.Create;
  Robot.setRobotViewer(RobotViewer);
  UdpClient := TUdpClient.Create(Self,IpcPort,IpcAdresse,StrToInt(IpcVitesse),FrmPosEcran);

  if (WSocketServer1.State = WSListening) then
    WSocketServer1.Close;

  //SocketServeur  en coute
  WSocketServer1.Port := ServeurPort;
  WSocketServer1.Addr := '0.0.0.0';
  WSocketServer1.ClientClass := TcpClient;
  WSocketServer1.Listen;
end;

// ------------ Menu Methodes --------------------------------------------------
procedure TFrmSimulRobot.Fermer1Click(Sender: TObject);
begin
  Close;
end;

procedure TFrmSimulRobot.IPC1Click(Sender: TObject);
begin
  FrmOptionIPC.Visible := true;
end;

procedure TFrmSimulRobot.Serveur1Click(Sender: TObject);
begin
  FrmOptionServeur.Visible := true;
end;

procedure TFrmSimulRobot.Robot1Click(Sender: TObject);
begin
  FrmOptionRobot.Visible := true;
end;

// ------------ Public Procedures ----------------------------------------------
procedure TFrmSimulRobot.ReceiveAction(Sender: TObject; Action: byte);
var
  RV : String;
begin
  if Action <> 1 then   //Kan Foutmelding op terecht komen
  begin
    RV := Robot.Bouche(Action);
  end;
  mmoServerMessages.Lines.Add('MS:Recieved ' + Chr(action));
end;

procedure TFrmSimulRobot.MiseOptionIPC(P:string;A:string;V:String);
begin
  IpcPort := P;
  IpcAdresse := A;
  IpcVitesse := V;
end;

// ------------ Procedures Priv -----------------------------------------------
procedure TFrmSimulRobot.LireProprieteServeur();
var
  iFileHandle:Integer;
  iFileLength:Integer;
  iBytesRead:Integer;
  Buffer:PChar;
  i,place:Integer;
  KindValue,Value:String;
begin
  try

    place := 1; KindValue := ''; Value := '';

    iFileHandle :=FileOpen('PropServ.ini',fmOpenRead);

    iFileLength :=FileSeek(iFileHandle,0,2);
    FileSeek(iFileHandle,0,0);

    Buffer :=PChar(AllocMem(iFileLength +1));
    iBytesRead :=FileRead(iFileHandle,Buffer^,iFileLength);

    FileClose(iFileHandle);

    for i := 0 to iBytesRead-1 do
    begin
      if ((Buffer[i] <> '=') And (Buffer[i] <> ';') And (place = 1)) then
      begin
        KindValue := KindValue + Buffer[i];
      end;
      if (Buffer[i] = '=') then
      begin
        place := 2;
      end;
      if ((Buffer[i] <> '=') And (Buffer[i] <> ';') And (place = 2)) then
      begin
        Value := Value + Buffer[i];
      end;
      if (Buffer[i] = ';') then
      begin
        place := 3;

        if (KindValue = 'ip') then
          ServeurAdresse := Value;
        if (KindValue = 'port') then
          ServeurPort := Value;

        KindValue := '';
        Value := '';
      end;
      if (Buffer[i] = #$A) then
        place := 1;

    end;
  finally
    FreeMem(Buffer);
  end;
end;

procedure TFrmSimulRobot.LireProprieteIpc();
var
  iFileHandle:Integer;
  iFileLength:Integer;
  iBytesRead:Integer;
  Buffer:PChar;
  i,place:Integer;
  KindValue,Value:String;
begin
  try

    place := 1; KindValue := ''; Value := '';

    iFileHandle :=FileOpen('PropIpc.ini',fmOpenRead);

    iFileLength :=FileSeek(iFileHandle,0,2);
    FileSeek(iFileHandle,0,0);

    Buffer :=PChar(AllocMem(iFileLength +1));
    iBytesRead :=FileRead(iFileHandle,Buffer^,iFileLength);

    FileClose(iFileHandle);

    for i := 0 to iBytesRead-1 do
    begin
      if ((Buffer[i] <> '=') And (Buffer[i] <> ';') And (place = 1)) then
      begin
        KindValue := KindValue + Buffer[i];
      end;
      if (Buffer[i] = '=') then
      begin
        place := 2;
      end;
      if ((Buffer[i] <> '=') And (Buffer[i] <> ';') And (place = 2)) then
      begin
        Value := Value + Buffer[i];
      end;
      if (Buffer[i] = ';') then
      begin
        place := 3;

        if (KindValue = 'ip') then
          IpcAdresse := Value;
        if (KindValue = 'port') then
          IpcPort := Value;
        if (KindValue = 'Vitesse') then
          IpcVitesse := Value;

        KindValue := '';
        Value := '';
      end;
      if (Buffer[i] = #$A) then
        place := 1;

    end;
  finally
    FreeMem(Buffer);
  end;

end;





end.
