unit sauveVRML;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
      StdCtrls, GLScene, GLObjects, ComCtrls, GLTree{, unitsauv, ObjetsSup}, GLGeomObjects;

type

//------------------------------------------------------------------------------
// Le class TSauveVRML
//------------------------------------------------------------------------------
TSauveVRML = class

  constructor Create;
  Destructor Destroy;

private

  Nom:String;
  Fichier:TextFile;
  GLScene:TGLScene;
  constante:integer;


  precision:integer;
  precision1a:integer;
  precision1b:integer;
  aenfant:integer;


  Function RempVirg (s: string) : string;
  Procedure CubeVRML (cube: TGLCube);
  Procedure CylindreVRML (cyl: TGLCylinder);
  Procedure ConeVRML (cone: TGLCone);
  Procedure SphereVRML (sphere: TGLSphere);
  {Procedure PyramideVRML (Pyramide: TGLPyramide);}
  {Procedure ToitVRML (Toit: TGLToit);}
  {Procedure DemiSphereVRML (Demi: TGLDemiSphere);}
  Procedure TorusVRML (Torus: TGLTorus);
  Procedure CameraVRML (camera: TGLCamera);
  Procedure LightVRML (light: TGLLightSource);
  procedure analyseTGL (ob : TGLBaseSceneObject);
  Procedure ImplementeObjets(GLScene:TGLScene);

public

  Procedure SauvegardeVRML(N:String;G:TGLScene);

end;
//------------------------------------------------------------------------------


implementation

constructor TSauveVRML.Create();
begin

  precision := 24;
  precision1a := 10;
  precision1b := 20;
  aenfant := 0;

end;

Destructor TSauveVRML.Destroy();
begin
end;

function TSauveVRML.RempVirg(s:String):String;
var
   I:Integer;
Begin
     For I:=1 to length(s) do
     Begin
        If s[I]=',' then
           S[I]:='.';
     end;
     RempVirg:=S;
end;

procedure TSauveVRML.CubeVRML(cube: TGLCube);
begin

     writeln(Fichier,'      Transform {');
     writeln(Fichier,'          translation  '+ RempVirg(FloatToStr(Cube.Position.X))+' '+ RempVirg(FloatToStr(Cube.Position.Y))+' '+ RempVirg(FloatToStr(Cube.Position.Z)));
     writeln(Fichier,'          children [');
     writeln(Fichier,'            Shape {');
     writeln(Fichier,'              appearance       Appearance');
     writeln(Fichier,'             	{');
     writeln(Fichier,'              	material 	Material');
     writeln(Fichier,'              	  {');
     writeln(Fichier,'              	  }');
     writeln(Fichier,'            	}');
     writeln(Fichier,'              geometry       Box {');
     writeln(Fichier,'                size ' + RempVirg(FloatToStr(Cube.CubeWidth)) + ' ' + RempVirg(FloatToStr(Cube.CubeHeight)) + ' ' + RempVirg(FloatToStr(Cube.CubeDepth)));
     writeln(Fichier,'              }');
     writeln(Fichier,'            }');
     aenfant := aenfant + 1;

end;

Procedure TSauveVRML.CylindreVRML(cyl: TGLCylinder);
Begin
     writeln(Fichier,'      Transform {');
     writeln(Fichier,'          translation  '+ RempVirg(FloatToStr(cyl.Position.X))+' '+ RempVirg(FloatToStr(cyl.Position.Y))+' '+ RempVirg(FloatToStr(cyl.Position.Z)));
     writeln(Fichier,'          children [');
     writeln(Fichier,'            Shape {');
     writeln(Fichier,'              appearance       Appearance');
     writeln(Fichier,'             	{');
     writeln(Fichier,'              	material 	Material');
     writeln(Fichier,'              	  {');
     writeln(Fichier,'              	  }');
     writeln(Fichier,'            	}');
     writeln(Fichier,'              geometry       Cylinder {');
     writeln(Fichier,'                height '+ RempVirg(FloatToStr(Cyl.Height)));
     writeln(Fichier,'                radius '+ RempVirg(FloatToStr(Cyl.TopRadius)));
     writeln(Fichier,'              }');
     writeln(Fichier,'            }');
     aenfant := aenfant + 1;

End;

Procedure TSauveVRML.ConeVRML(cone: TGLCone);
Begin

End;

Procedure TSauveVRML.SphereVRML(Sphere: TGLSphere);
Begin

End;

Procedure TSauveVRML.TorusVRML(Torus: TGLTorus);
Begin

End;

Procedure TSauveVRML.CameraVRML(camera: TGLCamera);
Begin
     writeln(Fichier,'PerspectiveCamera {');
     writeln(Fichier,'  position '+ RempVirg(FloatToStr(Camera.Position.X {.X})) + ' '
                                            + RempVirg(FloatToStr(Camera.Position.Y {.Y})) + ' '
                                            + RempVirg(FloatToStr(Camera.Position.Z {.Z})));
     writeln(Fichier,'    orientation 0 0 0 0');
     writeln(Fichier,'}');
End;

Procedure TSauveVRML.LightVRML(light: TGLLightSource);
Begin
     writeln(Fichier,'PointLight {');
     writeln(Fichier,'  on  TRUE');
     writeln(Fichier,'  intensity ' + RempVirg(FloatToStr(1-Light.LinearAttenuation)));
     writeln(Fichier,'  color ' + RempVirg(FloatToStr(Light.Diffuse.Red)) + ' '
                                          + RempVirg(FloatToStr(Light.Diffuse.Green)) + ' '
                                          + RempVirg(FloatToStr(Light.Diffuse.Blue)));
     writeln(Fichier,'  location ' + RempVirg(FloatToStr(Light.Position.X {.X})) + ' '
                                             + RempVirg(FloatToStr(Light.Position.Y {.Y})) + ' '
                                             + RempVirg(FloatToStr(Light.Position.Z {.Z})));
     writeln(Fichier,'}');
End;

Procedure TSauveVRML.ImplementeObjets(GLScene:TGLScene);
Var
   i,j,k:Integer;
   ExPyramide,ExToit,ExTorus,ExDemiSphere:Boolean;
   {Demi:TDemiSphere;}
Begin
  ExPyramide:=False;
  ExTorus:=False;
  ExToit:=False;
  ExDemiSphere:=False;
  For i:=0 to (GLScene.Objects.Count-1) do
   begin
    {If GLScene.Objects.Children[i] is TPyramide then
       ExPyramide:=True;}
    {If GLScene.Objects.Children[i] is TToit then
       ExToit:=True;}
    {If GLScene.Objects.Children[i] is TDemiSphere then
       ExDemiSphere:=True;}
    If GLScene.Objects.Children[i] is TGLTorus then
       ExTorus:=True;
   end;
  If ExPyramide=true then
     Begin
       writeln(Fichier,'  Material {');
       writeln(Fichier,'     transparency 1');
       writeln(Fichier,'  }');
       writeln(Fichier,'  DEF Pyramide Group {');
       writeln(Fichier,'      Coordinate3 {point[');
       writeln(Fichier,'          0 0 1,');
       writeln(Fichier,'          1 0 1,');
       writeln(Fichier,'          1 0 0,');
       writeln(Fichier,'          0 0 0,');
       writeln(Fichier,'          0.5 1 0.5]');
       writeln(Fichier,'      } #8 Vertices of the pyramide');
       writeln(Fichier,'      IndexedFaceSet { coordIndex [');
       writeln(Fichier,'          0,1,4,-1]}');
       writeln(Fichier,'      IndexedFaceSet { coordIndex [');
       writeln(Fichier,'          0,1,2,3,-1]}');
       writeln(Fichier,'      IndexedFaceSet { coordIndex [');
       writeln(Fichier,'          1,2,4,-1]}');
       writeln(Fichier,'      IndexedFaceSet { coordIndex [');
       writeln(Fichier,'          2,4,3,-1]}');
       writeln(Fichier,'      IndexedFaceSet { coordIndex [');
       writeln(Fichier,'          3,0,4,-1]}');
       writeln(Fichier,'      }');
       writeln(Fichier,'  }');
     End;
     If ExToit=true then
     Begin
       writeln(Fichier,'  Material {');
       writeln(Fichier,'     transparency 1');
       writeln(Fichier,'  }');
       writeln(Fichier,'  DEF Toit Group {');
       writeln(Fichier,'      Coordinate3 {point[');
       writeln(Fichier,'          0 0 1,');
       writeln(Fichier,'          1 0 1,');
       writeln(Fichier,'          1 0 0,');
       writeln(Fichier,'          0 0 0,');
       writeln(Fichier,'          0.25 1 0.5,');
       writeln(Fichier,'          0.75 1 0.5]');
       writeln(Fichier,'      } #8 Vertices of the toit');
       writeln(Fichier,'      IndexedFaceSet { coordIndex [');
       writeln(Fichier,'          0,1,5,4,-1]}');
       writeln(Fichier,'      IndexedFaceSet { coordIndex [');
       writeln(Fichier,'          0,1,2,3,-1]}');
       writeln(Fichier,'      IndexedFaceSet { coordIndex [');
       writeln(Fichier,'          1,2,5,-1]}');
       writeln(Fichier,'      IndexedFaceSet { coordIndex [');
       writeln(Fichier,'          2,5,4,3,-1]}');
       writeln(Fichier,'      IndexedFaceSet { coordIndex [');
       writeln(Fichier,'          3,0,4,-1]}');
       writeln(Fichier,'      }');
       writeln(Fichier,'  }');
     End;

  If ExDemiSphere=true then
     Begin
       writeln(Fichier,'  Material {');
       writeln(Fichier,'     transparency 1');
       writeln(Fichier,'  }');
       writeln(Fichier,'  DEF DemiSphere Group {');
       writeln(Fichier,'      Coordinate3 {point[');

       for j:=1 to Round(precision/4) do
         for i:=1 to (precision+1) do
           writeln(Fichier,'          '+RempVirg(FloatToStr(0.5*cos((j-1)/precision*2*pi)*cos((i-1)/precision*2*pi)+0.5))
                                                 +' '+RempVirg(FloatToStr(0.5*sin((j-1)/precision*2*pi)))
                                                 +' '+RempVirg(FloatToStr(0.5*cos((j-1)/precision*2*pi)*sin((i-1)/precision*2*pi)+0.5))+',');

       writeln(Fichier,'      ]} #8 Vertices of the DemiSphere');

       writeln(Fichier,'      IndexedFaceSet { coordIndex [');
       for i:=0 to (precision) do
          writeln(Fichier,'              '+RempVirg(FloatToStr(i))+', ');
          writeln(Fichier,'              '+RempVirg(FloatToStr(precision-1))+', -1]}');

       constante:=1;
       for i:=0 to Round((precision+1)*precision/4-precision-2) do
         begin
            if i<>(constante*precision+constante-1) then
                begin
                    writeln(Fichier,'      IndexedFaceSet { coordIndex [');
                    writeln(Fichier,'              '+RempVirg(FloatToStr(i))+', '
                                                              +RempVirg(FloatToStr(i+precision+1))+', '
                                                              +RempVirg(FloatToStr(i+precision+2))+', '
                                                              +RempVirg(FloatToStr(i+1))+', -1]}');
                end
            else inc(constante);
          end;


       writeln(Fichier,'      IndexedFaceSet { coordIndex [');
       writeln(Fichier,'              ');
       for j:=Round((precision+1)*precision/4-precision) to Round((precision+1)*precision/4-2) do
          writeln(Fichier,'              '+RempVirg(FloatToStr(j))+', ');
          writeln(Fichier,RempVirg(FloatToStr(j+1))+', -1]}');


       writeln(Fichier,'      }');
       writeln(Fichier,'  }');
     End;


   If exTorus=true then
     Begin
       writeln(Fichier,'  Material {');
       writeln(Fichier,'     transparency 1');
       writeln(Fichier,'  }');
       writeln(Fichier,'  DEF Torus Group {');
       writeln(Fichier,'      Coordinate3 {point[');

       for j:=0 to Round(precision1a) do
         for i:=0 to (precision1b) do
           writeln(Fichier,'          '+RempVirg(FloatToStr(0.5+(0.4+0.1*cos(j/precision1a*2*pi))*cos(i/precision1b*2*pi)))
                                                 +' '+RempVirg(FloatToStr(0.5+(0.4+0.1*cos((precision1a-j)/precision1a*2*pi))*sin(i/precision1b*2*pi)))
                                                 +' '+RempVirg(FloatToStr(0.1*sin(j/precision1a*2*pi)+0.5))+',');

       writeln(Fichier,'      ]} #8 Vertices of the Torus');

       constante:=1;
       for i:=0 to ((precision1a+1)*precision1b-1) do
         begin
            if i<>(constante*precision1b+constante-1) then
                begin
                    writeln(Fichier,'      IndexedFaceSet { coordIndex [');
                    writeln(Fichier,'              '+RempVirg(FloatToStr(i))+', '
                                                              +RempVirg(FloatToStr(i+1))+', '
                                                              +RempVirg(FloatToStr(i+precision1b+2))+', '
                                                              +RempVirg(FloatToStr(i+precision1b+1))+', -1]}');
                end
            else inc(constante);
          end;


       writeln(Fichier,'      }');
       writeln(Fichier,'  }');
     End;


End;

procedure TSauveVRML.analyseTGL(ob : TGLBaseSceneObject{;X:Integer;Y:Integer;Z:Integer});
var
  i:integer;
begin
     IF ob is TGLCube then
        Begin                                          //Pour les objets
          CubeVRML(ob as TGLCube);
        End;

     IF ob is TGLCylinder then
        Begin
          CylindreVRML(ob as TGLCylinder);
        End;

     IF ob is TGLCone then
        Begin
          ConeVRML(ob as TGLCone);
        End;

     IF ob is TGLSphere then
        Begin
          SphereVRML(ob as TGLSphere);
        End;

     IF ob is TGLTorus then
        Begin
          TorusVRML(ob as TGLTorus);
        End;

     for i:=0 to (ob.count-1) do
        Begin
          analyseTGL (ob.Children[i]);
        end;

     if aenfant <> 0 then
     begin
       writeln(Fichier,'          ]');
       writeln(Fichier,'      }');
       aenfant := aenfant - 1;
     end;

end;

procedure TSauveVRML.SauvegardeVRML(N:String;G:TGLScene);
var

  i:integer;
  test:TGLLightsource;

begin

  nom := n;
  GLScene := G;

  // Openen van de file
  assignfile(Fichier,nom);
  Rewrite(Fichier);

  // Begin van de vrml defenitie in de file
  {writeln(Fichier,'#VRML V1.0 ascii');
  writeln(Fichier,'');
  writeln(Fichier,'DEF Viewer Info { string "LACAL 3D" ');
  writeln(Fichier,'DEF Title Info { string "' + nom + '" ');
  writeln(Fichier,'Separator {');}


  //ImplementeObjets(GLScene);

  For i:=0 to (GLScene.Lights.Count-5) do {.LightSources.Count}
     Begin
            If (GLScene.Lights.Items[i] as TGLLightsource).Shining=true then {.LightSources.Children[i]}           //Pour les Lightsources
              Begin
                LightVRML(GLScene.Lights.Items[i] as TGLLightSource); {.LightSources.Children[i]}
              End;
     End;


  For i:=0 to (GLScene.Cameras.Count-1) do
     Begin
            {If (GLScene.Cameras.Children[i] as TGLCamera) =true then           //Pour les Cameras
              Begin}
                 //CameraVRML(GLScene.Cameras.Children[i] as TGLCamera);
              {End;}
     End;


  {writeln(Fichier,'Separator ');}

  For i:=0 to (GLScene.Objects.Count-1) do
    begin
      analyseTGL (GLScene.Objects.Children[i]);
    end;

  {writeln(Fichier,' ');}
  {writeln(Fichier,'');}

  CloseFile(Fichier);

end;

End.